mobjinfo[MT_CORK].speed = FRACUNIT
mobjinfo[MT_CORK].flags = $|MF_NOGRAVITY

//Add ghost trail to the cork to improve its visibility
addHook("MobjThinker",function(mo)
	if mo.flags&MF_MISSILE and mo.target and mo.target.player then
		local ghost = P_SpawnGhostMobj(mo)
		ghost.destscale = 0
		if not(gametyperules&GTR_FRIENDLY) //Add color trail to competitive gametypes
			ghost.colorized = true
			ghost.color = mo.target.player.skincolor
		end
		
		searchBlockmap("objects",function(r,f)
			if r and f and r.valid and f.valid
			and r.target and r.target.player
			and f.type == MT_METALSONIC_RACE
			and R_PointToDist2(r.x,r.y,f.x,f.y) <= r.radius + f.radius
				r.target.player.kills = $+1
				r.target.player.ammo = CV_FindVar("fangclipsize").value
				S_StartSound(mo,sfx_nmehit)
				S_StartSound(mo,sfx_rldend)
				P_ExplodeMissile(r)
			return end
			
			if not (r and f
			and (f.flags & MF_ENEMY
			or f.flags & MF_SHOOTABLE))
			or f == r.target
				return end
			
			local fheight = f.height * 2
			local rcenter = r.z + (r.height/2)
			local fcenter = f.z + (fheight/2)
			
			if R_PointToDist2(r.x,r.y,f.x,f.y) <= r.radius + (f.radius*3/2)
			and abs(rcenter-f.z) <= r.radius + fheight
				P_MoveOrigin(r,f.x,f.y,f.z)
			end
		end, mo)
	elseif mo.momx <= FRACUNIT
		mo.speed = 60*FRACUNIT
		mo.momx = $*60
		mo.momy = $*60
		mo.momz = $*60
	end
end,MT_CORK)